import 'package:rook_sdk_health_connect/src/domain/enums/hc_availability_status.dart';
import 'package:rook_sdk_health_connect/src/platform/rook_sdk_health_connect_platform_interface.dart';

class HCRookHealthPermissionsManager {

  /// Check if the Health Connect APK is installed in this device.
  Future<HCAvailabilityStatus> checkAvailability() {
    return RookSdkHealthConnectPlatform.instance.checkAvailability();
  }

  /// Launches the health Connect application.
  Future<void> openHealthConnectSettings() {
    return RookSdkHealthConnectPlatform.instance.openHealthConnectSettings();
  }

  /// Checks if this app is authorized to retrieve all types of data.
  Future<bool> hasAllPermissions() {
    return RookSdkHealthConnectPlatform.instance.hasAllPermissions();
  }

  /// Ask the user to authorize this app to retrieve all types of data.
  Future<void> requestAllPermissions() {
    return RookSdkHealthConnectPlatform.instance.requestAllPermissions();
  }

  /// Checks if this app is authorized to retrieve sleep data.
  Future<bool> hasSleepPermissions() {
    return RookSdkHealthConnectPlatform.instance.hasSleepPermissions();
  }

  /// Ask the user to authorize this app to retrieve sleep data.
  Future<void> requestSleepPermissions() {
    return RookSdkHealthConnectPlatform.instance.requestSleepPermissions();
  }

  /// Checks if this app is authorized to retrieve physical data.
  Future<bool> hasPhysicalPermissions() {
    return RookSdkHealthConnectPlatform.instance.hasPhysicalPermissions();
  }

  /// Ask the user to authorize this app to retrieve physical data.
  Future<void> requestPhysicalPermissions() {
    return RookSdkHealthConnectPlatform.instance.requestPhysicalPermissions();
  }

  /// Checks if this app is authorized to retrieve body data.
  Future<bool> hasBodyPermissions() {
    return RookSdkHealthConnectPlatform.instance.hasBodyPermissions();
  }

  /// Ask the user to authorize this app to retrieve body data.
  Future<void> requestBodyPermissions() {
    return RookSdkHealthConnectPlatform.instance.requestBodyPermissions();
  }
}
