import 'package:flutter_test/flutter_test.dart';
import 'package:rook_sdk_health_connect/rook_sdk_health_connect.dart';
import 'package:rook_sdk_health_connect/src/data/mapper/local_logging_level_mappers.dart';
import 'package:rook_sdk_health_connect/src/data/proto/protos.pbenum.dart';

void main() {
  group('LocalLoggingLevel to LocalLoggingLevelProto mappers', () {
    test(
      'GIVEN LocalLoggingLevel.advanced WHEN toProto THEN return LocalLoggingLevelProto.ADVANCED',
      () {
        const localLoggingLevel = LocalLoggingLevel.advanced;
        final result = localLoggingLevel.toProto();

        expect(result, LocalLoggingLevelProto.ADVANCED);
      },
    );

    test(
      'GIVEN LocalLoggingLevel.basic WHEN toProto THEN return LocalLoggingLevelProto.BASIC',
      () {
        const localLoggingLevel = LocalLoggingLevel.basic;
        final result = localLoggingLevel.toProto();

        expect(result, LocalLoggingLevelProto.BASIC);
      },
    );

    test(
      'GIVEN LocalLoggingLevel.none WHEN toProto THEN return LocalLoggingLevelProto.NONE',
      () {
        const localLoggingLevel = LocalLoggingLevel.none;
        final result = localLoggingLevel.toProto();

        expect(result, LocalLoggingLevelProto.NONE);
      },
    );
  });
}
